"======================================================================
|
|   Iliad.ILHeadElement class definition
|
 ======================================================================"

"======================================================================
|
| Copyright (c) 2008-2010 
| Nicolas Petton <petton.nicolas@gmail.com>,
| Sébastien Audier <sebastien.audier@gmail.com>
|
|
| This file is part of the Iliad framework.
|
| Permission is hereby granted, free of charge, to any person obtaining
| a copy of this software and associated documentation files (the 
| 'Software'), to deal in the Software without restriction, including 
| without limitation the rights to use, copy, modify, merge, publish, 
| distribute, sublicense, and/or sell copies of the Software, and to 
| permit persons to whom the Software is furnished to do so, subject to 
| the following conditions:
|
| The above copyright notice and this permission notice shall be 
| included in all copies or substantial portions of the Software.
|
| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.  
|
 ======================================================================"



ILHTMLBuilderElement subclass: ILHeadElement [

    <comment: nil>
    <category: 'Iliad-Core-XHTMLElements'>

    tag [
	<category: 'accessing'>
	^'head'
    ]

    profile: aString [
	<category: 'accessing attributes'>
	self attributeAt: 'profile' put: aString
    ]

    profiles: aCollection [
	<category: 'accessing attributes'>
	| profiles |
	profiles := WriteStream on: String new.
	aCollection do: [:each | profiles nextPutAll: each]
	    separatedBy: [profiles nextPutAll: ' '].
	self attributeAt: 'profile' put: profiles contents
    ]

    title [
	<category: 'accessing attributes'>
	^self add: ILTitleElement new
    ]

    title: aString [
	<category: 'accessing attributes'>
	^self add: (ILTitleElement new
	    text: aString;
	    yourself)
    ]

    style [
	<category: 'adding-conveniance'>
	^self add: (ILTextElement new
	    tag: 'style';
	    attributeAt: 'type' put: 'text/css';
	    yourself)
    ]

    style: aString [
	<category: 'adding-conveniance'>
	^self style
	    contents: aString;
	    yourself
    ]

    onEvent: event add: aString [
	<category: 'accessing attributes-events'>
	self doesNotUnderstandAttribute: 'on' , event
    ]

    beforePrintHtml [
	<category: 'printing'>
	(self meta)
	    httpEquiv: 'Content-Type';
	    content: self contentType
    ]
]
